/*  File: analyser-jets.h
 *  Project: Deductor
 *  Created by Zoltán Nagy on 9/8/13.
 *  Modified by D. Soper on 6 July 2017
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __analyzer_lhe_h__
#define __analyzer_lhe_h__

/*   project headers  */
#include <user.h>

/*   Define some namespaces  */
using namespace std;
using namespace duct;

/*   
 *   This is the declaration of the analyzer class.
 */
class UserLHE : public user<hhc>
{
public:
  
  /*   User defined init function. It is called once at the begining of the calculation.  */
  void initfunc();
  
  /*   The analyzer routine. It creates the lhe file.   */
  void userfunc(const shower_history<hhc>&);
  
  /* Generates an underlying event for the userfunc */
  void UEvent(double pplus, double pminus, int c, int Ngluons, double PTbar);
  
  /* A file stream */
  ofstream lhe;
  
  /* To count the events */
  int eventnumber;
  int MaxLHEevents;
  
  /* Collision parameters */
  double rts;
  int hadronA, hadronB;
  
  /* Random numbers */
  std::random_device rdseed; // This will provide a random seed in initfunc().
  std::mt19937 myran;  // A particular random number generator, with default seed,
};

#endif


